//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_DISTRIBUTEPARTICLE_H
#define OHMMS_DISTRIBUTEPARTICLE_H

namespace OHMMS {

  /** distribute the particle set over omp/mpi nodes
   */
  class DistributeParticle: public TransformParticleSet {

  public:

    DistributeParticle(Particle_t& pin, Particle_t& pout): TransformParticleSet(pin,pout) 
    {}

    bool put(xmlNodePtr cur);
  };
}

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 158 $   $Date: 2004-11-03 16:11:26 -0600 (Wed, 03 Nov 2004) $
 * $Id: DistributeParticle.h 158 2004-11-03 22:11:26Z jnkim $ 
 ***************************************************************************/
