      function trmlen(string)
c Trims blanks and tabs off end of character string--actually, returns
c length of string ignoring trailing blanks and tabs.
c Note the following nonprinting characters:
c blank=' '  and  tab='	'. (Ascii decimal numbers 32 and 9 resp).
c Warning: when this routine is translated among machines,
c e.g. by Kermit, the desired tab character may not translate properly
c and might have to be put back in using the local editor.
      implicit none
      integer trmlen
      character string*(*),blank*1,tab*1
      parameter (blank=' ',tab='	')

      trmlen=len(string)
   10 if(trmlen.eq.0) return
c     Hack blanks or tabs chars off end one at a time:
c     (the second one below is a tab character)
      if   (string(trmlen:trmlen).eq.blank
     $ .or. string(trmlen:trmlen).eq.tab) then
        trmlen=trmlen-1
        goto 10
      end if
      return
      end
