/****************************************************************************
** Form implementation generated from reading ui file 'ParticleSetEditor.ui'
**
** Created: Fri Apr 16 11:35:30 2004
**      by: The User Interface Compiler ($Id: ParticleSetEditor.cpp 151 2004-11-02 23:51:14Z jnkim $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "OhmmsQt/ParticleSetEditor.h"
#include "Utilities/SpeciesCollection.h"
#include "OhmmsQt/SetSpeciesDialog.h"

#include <set>
#include <qvariant.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qtextedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qtable.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qhbox.h>
//#include <glbox.h>
//#include <globjwin.h>
/*
 *  Constructs a ParticleSetEditor as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ParticleSetEditor::ParticleSetEditor( QWidget* parent, const char* name, 
				      WFlags fl )
  : QWidget(parent, name, fl), 
    d_lattice(9), d_recip(9), d_labels(10),
    refPtcl(NULL)
{
  if ( !name )
    setName( "ShowASuperCell" );

  QLabel* al = new QLabel( this, "a1" );
  al->setGeometry( QRect( 40, 35, 20, 20 ) );
  d_labels.insert(0,al);
  
  al = new QLabel( this, "a2" );
  al->setGeometry( QRect( 40, 65, 20, 20 ) );
  d_labels.insert(1,al);
    
  al = new QLabel( this, "a3" );
  al->setGeometry( QRect( 40, 95, 20, 20 ) );
  d_labels.insert(2,al);
    
  al = new QLabel( this, "b1" );
  al->setGeometry( QRect( 40, 155, 20, 20 ) );
  d_labels.insert(3,al);

  al= new QLabel( this, "b2" );
  al->setGeometry( QRect( 40, 185, 20, 20 ) );
  d_labels.insert(4,al);

  al= new QLabel( this, "b3" );
  al->setGeometry( QRect( 40, 215, 20, 20 ) );
  d_labels.insert(5,al);

  al = new QLabel( this, "lattice" );
  al->setGeometry( QRect( 40, 10, 300, 21 ) );
  d_labels.insert(6,al);

  al = new QLabel( this, "reciprocal" );
  al->setGeometry( QRect( 40, 130, 300, 21 ) );
  d_labels.insert(7,al);

  al = new QLabel( this, "ptclcontent" );
  al->setGeometry( QRect( 40, 250, 200, 21 ) );
  d_labels.insert(8,al);

  QLineEdit* a = new QLineEdit( this, "lat00" );
  a->setGeometry( QRect( 70, 35, 106, 22 ) );
  d_lattice.insert(0,a);

  a = new QLineEdit( this, "lat01" );
  a->setGeometry( QRect( 200, 35, 106, 22 ) );
  d_lattice.insert(1,a);

  a = new QLineEdit( this, "lat02" );
  a->setGeometry( QRect( 330, 35, 106, 22 ) );
  d_lattice.insert(2,a);

  a = new QLineEdit( this, "lat10" );
  a->setGeometry( QRect( 70, 65, 106, 22 ) );
  d_lattice.insert(3,a);

  a = new QLineEdit( this, "lat11" );
  a->setGeometry( QRect( 200, 65, 106, 20 ) );
  d_lattice.insert(4,a);

  a = new QLineEdit( this, "lat12" );
  a->setGeometry( QRect( 330, 65, 106, 22 ) );
  d_lattice.insert(5,a);

  a = new QLineEdit( this, "lat20" );
  a->setGeometry( QRect( 70, 95, 106, 22 ) );
  d_lattice.insert(6,a);

  a = new QLineEdit( this, "lat21" );
  a->setGeometry( QRect( 200, 95, 106, 22 ) );
  d_lattice.insert(7,a);

  a = new QLineEdit( this, "lat22" );
  a->setGeometry( QRect( 330, 95, 106, 22 ) );
  d_lattice.insert(8,a);

  QLineEdit *b = new QLineEdit( this, "b00" );
  b->setGeometry( QRect( 70, 155, 106, 22 ) );
  d_recip.insert(0,b);

  b = new QLineEdit( this, "b01" );
  b->setGeometry( QRect( 200, 155, 106, 22 ) );
  d_recip.insert(1,b);

  b = new QLineEdit( this, "b02" );
  b->setGeometry( QRect( 330, 155, 106, 22 ) );
  d_recip.insert(2,b);

  b = new QLineEdit( this, "b10" );
  b->setGeometry( QRect( 70, 185, 106, 22 ) );
  d_recip.insert(3,b);

  b = new QLineEdit( this, "b11" );
  b->setGeometry( QRect( 200, 185, 106, 22 ) );
  d_recip.insert(4,b);

  b = new QLineEdit( this, "b12" );
  b->setGeometry( QRect( 330, 185, 106, 22 ) );
  d_recip.insert(5,b);

  b = new QLineEdit( this, "b20" );
  b->setGeometry( QRect( 70, 215, 106, 22 ) );
  d_recip.insert(6,b);

  b = new QLineEdit( this, "b21" );
  b->setGeometry( QRect( 200, 215, 106, 22 ) );
  d_recip.insert(7,b);

  b = new QLineEdit( this, "b22" );
  b->setGeometry( QRect( 330, 215, 106, 22 ) );
  d_recip.insert(8,b);

  ///create a QTable that shows the species x y z
  ptcl_data = new QTable(this,"ptclcontent");
  ptcl_data->setNumCols(4);
  ptcl_data->setGeometry( QRect( 40, 280, 400, 200 ) );
  ptcl_data->setColumnWidth(0,50);

  ptcl_R_unit = new QButtonGroup( this, "posunit" );
  ptcl_R_unit->setGeometry( QRect( 160, 240, 190, 30 ) );
  ptcl_R_unit->setFrameShape( QButtonGroup::NoFrame );
  ptcl_R_unit->setRadioButtonExclusive(true);

  QRadioButton *radioButton1=new QRadioButton(ptcl_R_unit, "cart" );
  radioButton1->setText( tr( "Cartesian" ) );
  radioButton1->setGeometry( QRect( 0, 10, 92, 20 ) );

  radioButton1 = new QRadioButton(ptcl_R_unit, "unitcell" );
  radioButton1->setText( tr( "Unit Cell" ) );
  radioButton1->setGeometry( QRect( 100, 10, 92, 20 ) );

  ptcl_R_unit->setButton(0);
  connect(ptcl_R_unit,SIGNAL(pressed(int)), this, SLOT(updatePosUnit(int)));

  resize(QSize(500, 400));
  languageChange();
  clearWState( WState_Polished );
}

/*
 *  Destroys the object and frees any allocated resources
 */
ParticleSetEditor::~ParticleSetEditor()
{
  for(int i=0; i<ptclStack.size(); i++) delete ptclStack[i];
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ParticleSetEditor::languageChange()
{
  setCaption( tr( "Supercell Configuration" ) );
  d_labels[0]->setText( tr( "<font size=\"+1\">a<sub>1</sub></font>" ) );
  d_labels[1]->setText( tr( "<font size=\"+1\">a<sub>2</sub></font>" ) );
  d_labels[2]->setText( tr( "<font size=\"+1\">a<sub>3</sub></font>" ) );
  d_labels[3]->setText( tr( "<font size=\"+1\">b<sub>1</sub></font>" ) );
  d_labels[4]->setText( tr( "<font size=\"+1\">b<sub>2</sub></font>" ) );
  d_labels[5]->setText( tr( "<font size=\"+1\">b<sub>3</sub></font>" ) );
  d_labels[6]->setText( tr( "<b><font size=\"+1\">Lattice Vectors</font></b>" ) );
  d_labels[7]->setText( tr( "<b><font size=\"+1\">Reciprocal Vectors</font></b>" ) );
  d_labels[8]->setText( tr( "<b><font size=\"+1\">Particles</font></b>" ) );

//   buttonHelp->setText( tr( "&Help" ) );
//   buttonHelp->setAccel( QKeySequence( tr( "F1" ) ) );
//   buttonOk->setText( tr( "&OK" ) );
//   buttonOk->setAccel( QKeySequence( QString::null ) );
//   buttonCancel->setText( tr( "&Cancel" ) );
//   buttonCancel->setAccel( QKeySequence( QString::null ) );

  top_cart.append("type");
  top_cart.append("X-axis");
  top_cart.append("Y-axis");
  top_cart.append("Z-axis");

  top_unit.append("type");
  top_unit.append("a1");
  top_unit.append("a2");
  top_unit.append("a3");
}


void ParticleSetEditor::updateLattice(){

  d_lattice[0]->setText(QString("%1").arg(myPtcl.Lattice.R(0,0)));
  d_lattice[1]->setText(QString("%1").arg(myPtcl.Lattice.R(0,1)));
  d_lattice[2]->setText(QString("%1").arg(myPtcl.Lattice.R(0,2)));
  d_lattice[3]->setText(QString("%1").arg(myPtcl.Lattice.R(1,0)));
  d_lattice[4]->setText(QString("%1").arg(myPtcl.Lattice.R(1,1)));
  d_lattice[5]->setText(QString("%1").arg(myPtcl.Lattice.R(1,2)));
  d_lattice[6]->setText(QString("%1").arg(myPtcl.Lattice.R(2,0)));
  d_lattice[7]->setText(QString("%1").arg(myPtcl.Lattice.R(2,1)));
  d_lattice[8]->setText(QString("%1").arg(myPtcl.Lattice.R(2,2)));

  d_recip[0]->setText(QString("%1").arg(TWOPI*myPtcl.Lattice.G(0,0)));
  d_recip[1]->setText(QString("%1").arg(TWOPI*myPtcl.Lattice.G(1,0)));
  d_recip[2]->setText(QString("%1").arg(TWOPI*myPtcl.Lattice.G(2,0)));
  d_recip[3]->setText(QString("%1").arg(TWOPI*myPtcl.Lattice.G(0,1)));
  d_recip[4]->setText(QString("%1").arg(TWOPI*myPtcl.Lattice.G(1,1)));
  d_recip[5]->setText(QString("%1").arg(TWOPI*myPtcl.Lattice.G(2,1)));
  d_recip[6]->setText(QString("%1").arg(TWOPI*myPtcl.Lattice.G(0,2)));
  d_recip[7]->setText(QString("%1").arg(TWOPI*myPtcl.Lattice.G(1,2)));
  d_recip[8]->setText(QString("%1").arg(TWOPI*myPtcl.Lattice.G(2,2)));

}

void ParticleSetEditor::updateConfiguration() {

  ///resize the table, if necessary
  if(ptcl_data->numRows() != myPtcl.getTotalNum()) 
    ptcl_data->setNumRows(myPtcl.getTotalNum());

  if(myPtcl.R.InUnit) {
    ptcl_R_unit->setButton(1);
    ptcl_data->setColumnLabels(top_unit);
  } else {
    ptcl_R_unit->setButton(0);
    ptcl_data->setColumnLabels(top_cart);
  }

  updatePos();
}

void ParticleSetEditor::updatePos() {

  for(int i=0; i<myPtcl.getTotalNum(); i++) {
    ptcl_data->setText(i,0,species_names[myPtcl.GroupID[i]]);
    ptcl_data->setText(i,1,QString("%1").arg(myPtcl.R[i][0]));
    ptcl_data->setText(i,2,QString("%1").arg(myPtcl.R[i][1]));
    ptcl_data->setText(i,3,QString("%1").arg(myPtcl.R[i][2]));
  }
}

void 
ParticleSetEditor::updatePosUnit(int n) {

  //do not need anything
  if(n == myPtcl.R.InUnit) return;

  if(n) {//unit
    myPtcl.Lattice.convert2Unit(myPtcl.R);
  } else {
    myPtcl.Lattice.convert2Cart(myPtcl.R);
  }
  updatePos();  
}

void 
ParticleSetEditor::setConfiguration(Particle_t* P, bool makecopy) {

   
 refPtcl = P;

 myPtcl.Lattice = P->Lattice;
 myPtcl.resize(P->getTotalNum());
 myPtcl.R.InUnit = P->R.InUnit;
 myPtcl.R = P->R;
 myPtcl.ID = P->ID;
 myPtcl.GroupID = P->GroupID;

 updateSpeciesInfo();
 updateLattice();
 updateConfiguration();
}

void 
ParticleSetEditor::updateSpeciesInfo() {

  set<int> ionid;
  ionid.insert(myPtcl.GroupID.begin(), myPtcl.GroupID.end());
  P_groups.resize(ionid.size());
  for(int iat=0; iat<myPtcl.GroupID.size(); iat++)  
    P_groups[myPtcl.GroupID[iat]]++;

  ///update the species table
  SpeciesBase* species = SpeciesCollection::getSpecies();

  if(!species->getTotalNum()) {
    SetSpeciesDialog fd(ionid.size());
    if(fd.exec() == QDialog::Accepted) {
      fd.updateSpecies(species);
    }
  }

  species_names.resize(species->getTotalNum());
  for(int i=0; i<species->getTotalNum(); i++) 
    species_names[i] = species->Name[i].c_str();
}
