//////////////////////////////////////////////////////////////////
// (c) Copyright 2003  by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#include <qmainwindow.h>
#include "QXmlTreeBuilder.h"
#include <qapplication.h>

/**\file show_xml.cpp
 * The main routine that creates a tree using QListView from a xml file
 */
int main(int argc, char **argv) {

  QApplication a(argc,argv);
  XmlTreeBuilder *owin= new XmlTreeBuilder();

  if(argc>1) {
    owin->parse(argv[1]);
  }
  owin->show();
  a.connect(&a,SIGNAL(lastWindowClosed()), &a, SLOT(quit()));
  return a.exec();
}
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: show_xml.cpp 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
