#####################################
#subdir Propagators
#####################################
@propagators = ("PropagatorBase",
		"VerletPropagator",
		"VelocityVerlet",
		"LangevinVVerlet",
                "NoseLeapFrog",
		"NoPropagator",
		"EPNHydroVerlet",
		"EPNVerlet",
		"CGPropagator",
		"RecordPropagator",
		"ConstraintBase");
if($fc_able) {
    push(@propagators,"ForceConstant");
    push(@propagators,"ForceConstant.IO");
}

if($dimer_able) {
    push(@propagators,"DimerPropagator");
}

&add_ohmms_package("PROPBASE",
                   "Propagators",
                   @propagators);
1;
