//////////////////////////////////////////////////////////////////
// (c) Copyright 2003- by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_SLATERKOSTERTB_LIBXMLREADER_H
#define OHMMS_SLATERKOSTERTB_LIBXMLREADER_H

namespace OHMMS {

  class SlaterKosterTB;

   /*!\class SKTBLibxmlReader
    *\brief Parse an xml file using libxml
    *\todo Implement SlaterKosterTBRef class, which is a friend of SlaterKosterTB
    * make few members available to the reader.
    */
  class SKTBLibxmlReader {

    SlaterKosterTB& ref_;

  public:
    SKTBLibxmlReader(SlaterKosterTB& atb): ref_(atb) { }
    bool parser(const char*);
  };
}
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: SKTBLibxmlReader.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
 
