//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#ifndef OHMMS_SLATERKOSTER_TYPES_H
#define OHMMS_SLATERKOSTER_TYPES_H

#include "ohmms-config.h"
#ifndef SLATERKOSTERARRAYBASE_H
#include "SlaterKoster/SlaterKosterBase.h"
#endif

#ifndef OHMMS_SPARSEMATRIX_H
#include "SparseMatrix/SparseMatrix.h"
#endif
#include <vector>

namespace OHMMS {

  // definition of an array of SlaterKosterComp<Scalar_t>*
  typedef std::vector<SlaterKosterComp<OHMMS_PRECISION>* > SKArray_t;

}

#endif /* OHMMS_SLATERKOSTER_TYPE_H */

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: SKTypes.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/

