#!/usr/bin/env perl
# convert from NRL to OHMMS format
# only single species
$i=0;
$iv = 0;
$ia = 0;
while(<>) {
chop($_);
@pos = split(' ');

if($i == 2) {
    $nspecies = $pos[0];
} 
if($i == 3) {
    $rcut = $pos[0];
    $screen = $pos[1];
} 
if($i == 4) {
    $norb = $pos[0];
} 
if($i == 5) {
    $mass = $pos[0];
}
if($i == 7) {
    $lam = $pos[0];
}
if($i > 7 && $i<24) {
    $ax[$ia] = $pos[0];
    $ia++;
}
if($i>=24) {
  if($iv<40) {
      $h[$iv] = $pos[0];
  } else {
      $s[$iv-40] = $pos[0];
  }
    $iv++;
}
$i++;
}

printf "<species name=\"Si\">\n";
printf "<mass> $mass </mass>\n";
printf "<valence> 4 </valence>\n";
printf "<orbital> 0 </orbital>\n";
printf "<orbital> 1 </orbital>\n";
    if($norb == 9) {
	printf "<orbital> 2 </orbital>\n";
    }
printf "</species>\n";
printf "<onsite name=\"nrl\">\n";
printf "species Si\n";
printf "0 0 0 $ax[1] $ax[2] $ax[3]\n";
printf "1 1 0 $ax[5] $ax[6] $ax[7]\n";
if($norb == 9) {
    printf "2 4 0 $ax[9] $ax[10] $ax[11]\n";
    $crystal = $ax[12]-$ax[8];
    printf "2 5 $crystal $ax[13] $ax[14] $ax[15]\n";
}
printf "</onsite>\n";
printf "<TBPARAM name=\"nrl\">\n";
printf "bond Si Si\n";
printf "rcut =  $rcut\n";
printf "screenl  =  $screen\n";

printf "0 0 -1 0 0 $ax[0]\n";
printf "0 0 0 0 0\n";
printf "$h[0] $h[1] $h[2] $h[3]\n";
printf "$s[0] $s[1] $s[2] $s[3]\n";

printf "0 1 0 0 1\n";
printf "$h[4] $h[5] $h[6] $h[7]\n";
printf "$s[4] $s[5] $s[6] $s[7]\n";

printf "1 1 -1 1 1 $ax[4]\n";

printf "1 1 0 1 1\n";
printf "$h[8] $h[9] $h[10] $h[11]\n";
printf "$s[8] $s[9] $s[10] $s[11]\n";

printf "1 1 1 1 1\n";
printf "$h[12] $h[13] $h[14] $h[15]\n";
printf "$s[12] $s[13] $s[14] $s[15]\n";


if($norb == 9) {
    printf "0 2 0 0 4\n";
    printf "$h[16] $h[17] $h[18] $h[19]\n";
    printf "$s[16] $s[17] $s[18] $s[19]\n";

    printf "1 2 0 1 4\n";
    printf "$h[20] $h[21] $h[22] $h[23]\n";
    printf "$s[20] $s[21] $s[22] $s[23]\n";

    printf "1 2 1 1 4\n";
    printf "$h[24] $h[25] $h[26] $h[27]\n";
    printf "$s[24] $s[25] $s[26] $s[27]\n";

    printf "2 2 -1 4 4 $ax[8]\n";

    printf "2 2 0 4 4\n";
    printf "$h[28] $h[29] $h[30] $h[31]\n";
    printf "$s[28] $s[29] $s[30] $s[31]\n";

    printf "2 2 1 4 4\n";
    printf "$h[32] $h[33] $h[34] $h[35]\n";
    printf "$s[32] $s[33] $s[34] $s[35]\n";

    printf "2 2 2 4 4\n";
    printf "$h[36] $h[37] $h[38] $h[39]\n";
    printf "$s[36] $s[37] $s[38] $s[39]\n";
}

printf "</TBPARAM>\n";
