//////////////////////////////////////////////////////////////////
// (c) Copyright 2004-  by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_PARTICLESETBUILD_H
#define OHHMS_PARTICLESETBUILD_H

#include "AppBase/OhmmsElementSet.h"

namespace OHMMS {

  class ParticleSetBuild: public OhmmsElementBase {

  public:

    // constructors and destructors
    ParticleSetBuild(OhmmsElementSet& nodelist, const char* aname="build");

    bool get(std::ostream& os) const;
    bool put(std::istream& is);
    bool put(xmlNodePtr cur);
    void reset();

  private:

    OhmmsElementSet& NodeList;
  };
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 157 $   $Date: 2004-11-03 16:10:50 -0600 (Wed, 03 Nov 2004) $
 * $Id: ParticleSetBuild.h 157 2004-11-03 22:10:50Z jnkim $ 
 ***************************************************************************/
