/****************************************************************************
** Form interface generated from reading ui file 'SetParticleSet.ui'
**
** Created: Fri Apr 16 11:34:54 2004
**      by: The User Interface Compiler ($Id: ParticleSetEditor.h 151 2004-11-02 23:51:14Z jnkim $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef SHOWASUPERCELL_H
#define SHOWASUPERCELL_H

#include <qvariant.h>
#include <qframe.h>
#include <qptrvector.h>
#include "Particle/ParticleSet.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QLabel;
class QPushButton;
class QLineEdit;
class QTextEdit;
class QTable;
class QButtonGroup;
//class QSplitter;

class ParticleSetEditor : public QWidget
{
  Q_OBJECT

public:

  typedef OHMMS::ParticleSet Particle_t;
  ParticleSetEditor( QWidget* parent = 0, const char* name = 0,  WFlags fl = 0 );
  ~ParticleSetEditor();
  
  void setConfiguration(Particle_t* P, bool makecopy=true);

public slots:

  //@{update the contents of Qt widgets
  ///update lattice only
  void updateLattice();

  ///update configuration: unit checking, species, numbers etc
  void updateConfiguration();

  ///update positions
  void updatePos();

  ///update species data
  void updateSpeciesInfo();

  ///update unit of positions
  void updatePosUnit(int);
  ///@}

private:

  QPushButton* buttonHelp;
  QPushButton* buttonOk;
  QPushButton* buttonCancel;
  
  QPtrVector<QLabel> d_labels;
  QPtrVector<QLineEdit> d_lattice;
  QPtrVector<QLineEdit> d_recip;
  QTable* ptcl_data;
  QButtonGroup* ptcl_R_unit;

  QStringList top_cart, top_unit;

  std::vector<QString> species_names;

protected:

  QHBoxLayout* Layout1;
  Particle_t *refPtcl;
  //ParticleBase<float,OHMMS_DIM> myPtcl;
  Particle_t myPtcl;
  vector<int> P_groups;

protected slots:

  virtual void languageChange();

private:
  vector<Particle_t*> ptclStack;
};

#endif // SHOWASUPERCELL_H
