#####################################
#subdir Particle
#####################################
@ptclextra;

@ptclbase =("ParticleSet",
	    "NNEngine",
	    "NNSimpleEngine",
	    "NNRegGridEngine",
	    "NNEngineBuilder"
            );

if($mpi) {
  push(@ptclbase, "ParticleSet.MPI");
  push(@ptclbase, "NNSpatialEngine");
  push(@ptclbase, "NNSpatialEngine.OOMPI");
}

&add_ohmms_package("PARTICLE",
                   "Particle",
		   @ptclbase
		   );

if($tb_able || $fc_able) {
    push(@ptclextra, "ParticleOperators");
}

if(@ptclextra) {
    &add_ohmms_package("PTCLEXTRA",
		       "Particle",
		       @ptclextra
		       );
}
1;

